// common response codes passed back to the window access class
// for supported screen emulators
#define NO_ACTION 0
#define CURSOR_RIGHT 1
#define CURSOR_LEFT 2
#define CURSOR_UP 3
#define CURSOR_DOWN 4
#define REVERSE_ON 5
#define REVERSE_OFF 6
#define Bell 7
#define Backspace 8
#define Tab 9
#define Line_Feed 0xA
#define Home 0xB
#define Clear 0xC
#define Carriage_Return 0xD
#define UNDERLINE_ON 0x10
#define UNDERLINE_OFF 0x11
#define CLEAR_EOS 0x12
#define CLEAR_EOL 0x13
#define SET_CURSOR 0x14

// common screen emulator functions
// provides the interface needed for all the supported screen emulators
class common_emulator {
private:
	// data and variables
	// operations
protected:
	// data and variables
	// operations
	int comm_emulator_detect ( char textcr ) ;
	int process_comm_emulator_sequence ( char textcr ) ;
public:
	// data and variables
	int new_x, new_y ;
	// operations
	common_emulator() ;
	virtual int process_emulation_sequence ( char textcr ) ;
	virtual int emulation_detect ( char textcr ) ;
	virtual int emulation_in_progress ( void ) ;
	virtual int emulation_sequence_pending ( void ) ;
	virtual int find_next_tab ( int current_x ) ;
	virtual void modify_tab ( int column, char set_flag ) ;
} ;

