// config.h - manage and set configuration options
void display_config_data ( void ) ;
void save_config_data ( void ) ;
void get_config_data ( void ) ;
BOOL get_new_font ( HWND hWnd, LOGFONT *lf, COLORREF *text_colour ) ;
BOOL get_new_colour ( HWND hWnd, COLORREF *colour ) ;
BOOL CALLBACK _export DefineKeyMap (HWND, UINT, WPARAM, LPARAM);

// screen emulation codes
#define NO_EMULATION 0
#define VT100_EMUL   1
#define GO51_EMUL    2

// keymap states
#define NORMAL_CHAR 0x00
#define SHIFTED 0x1
#define CONTROL 0x2
#define KEY_COUNT 25
#define CHARS_PER_KEY 4
struct keymap_type {
	unsigned char keys[3][KEY_COUNT][CHARS_PER_KEY] ; } ;

// system wide configuration info
struct config_info_type {
	short int emulation ;        				// default emulation
	COLORREF fore_colour ; 		 				// default foreground colour
	COLORREF back_colour ; 		 				// default background colour
#ifdef __WIN32__
	unsigned char reserved_4[50] ;         // unused (win32)
#else
	LOGFONT font ; 		       				// default font (win16)
#endif
	short int base_addr ;        				// IO base address
	short int hard_drives ;     				// no. of hard drives mounted
	short int sector_size ;      				// HDISK sector size
	struct keymap_type keymap ; 				// keyboard translation table
	char user_dir[200] ;                	// path to working files
	short int reserved_1 ;             		// reserved for DOS variant
	short int reserved_2 ;
	char reserved_3 ;
	unsigned char irq ;                    // IO port irq no.
	unsigned char dma ;                    // IO port DMA channel (unused)
#ifndef __WIN32__
	unsigned char reserved_4[60] ;         // unused (win16 & DOS)
#else
	LOGFONT font ; 		       				// default font (win32)
#endif
	char cmd_prompt[40] ;           // command prompt
  char del_key ;                  // ASCII delete code
						} ;

extern struct config_info_type system_config ;
extern unsigned char vtkey_to_udfkey[256] ;
