#include <string.h>
#include <stdio.h>
#include <memory.h>

#include <windows.h>
#include <windowsx.h>
#include <commdlg.h>

//****************************************************************************
char SelectedFile[256];

//****************************************************************************
//
//****************************************************************************
FILE *OpenSaveFile(HWND hPar,char *InitialFileStr,char *ExtStr,char *ModeStr)
{
	OPENFILENAME ofn;
	char InitialFile[60],Filter[60];

	// Load up the initial file spec and the filter from parameters
	// Note that it's not possible to add \0 using sprintf so replace them afterward
	sprintf(InitialFile,"%s.%3s",InitialFileStr,ExtStr);
	sprintf(Filter," |*.%s||",ExtStr);
	Filter[1]=0;Filter[7]=0;Filter[8]=0;

	// Setup OFN
	memset(&ofn, 0, sizeof(OPENFILENAME));
	ofn.lStructSize = sizeof(OPENFILENAME);
	ofn.hwndOwner = hPar;
	ofn.lpstrFilter = Filter;
	ofn.lpstrFile= InitialFile;
	ofn.nMaxFile = sizeof(InitialFile);
	ofn.lpstrFileTitle = SelectedFile;
	ofn.nMaxFileTitle = sizeof(SelectedFile);
	ofn.lpstrInitialDir = NULL;
	ofn.Flags = OFN_SHOWHELP | OFN_OVERWRITEPROMPT;

	if (GetSaveFileName(&ofn))	return(fopen(SelectedFile,ModeStr));
	else						return(NULL);
}
//****************************************************************************
//
//****************************************************************************
FILE *OpenLoadFile(HWND hPar,char *InitialFileStr,char *ExtStr,char *ModeStr)
{
	OPENFILENAME ofn;
	char InitialFile[60],Filter[60];

	// Load up the initial file spec and the filter from parameters
	// Note that it's not possible to add \0 using sprintf so replace them afterward
	sprintf(InitialFile,"%s.%3s",InitialFileStr,ExtStr);
	sprintf(Filter," |*.%s||",ExtStr);
	Filter[1]=0;Filter[7]=0;Filter[8]=0;

	// Setup OFN
	memset(&ofn, 0, sizeof(OPENFILENAME));
	ofn.lStructSize = sizeof(OPENFILENAME);
	ofn.hwndOwner = hPar;
	ofn.lpstrFilter = Filter;
	ofn.lpstrFile= InitialFile;
	ofn.nMaxFile = sizeof(InitialFile);
	ofn.lpstrFileTitle = SelectedFile;
	ofn.nMaxFileTitle = sizeof(SelectedFile);
	ofn.lpstrInitialDir = NULL;
	ofn.Flags = OFN_SHOWHELP | OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST ;

	if (GetOpenFileName(&ofn))	return(fopen(SelectedFile,ModeStr));
	else						return(NULL);

}
//****************************************************************************
//
//****************************************************************************
char *ActiveFileName(void)
{
	// Simply returns the currently selected filename
	return(&SelectedFile[0]);
}


