class graphics_support {
private:
	// data and variables
	HDC GhDC ;
	HBITMAP oldbmap, gbitmap ;
	HPALETTE palette, old_palette ;
	float x_scaling_factor, y_scaling_factor ;
	unsigned current_x, current_y, max_x, max_y ;
	COLORREF current_col ;
  LOGPALETTE *pal_data ;
	// operations
	COLORREF evaluate_colour ( unsigned char in_colour ) ;
	unsigned evaluate_x ( unsigned x_in ) ;
	unsigned evaluate_y ( unsigned y_in ) ;
  HPEN CreateReqdPen ( unsigned char width,
                       unsigned char style,
                       unsigned char col ) ;
public:
	// data and variables
	// operations
	~graphics_support() ;
	graphics_support ( HDC hDC, unsigned x_pixels, unsigned y_pixels, float x_scale, float y_scale ) ;
	void cursor_update ( unsigned x, unsigned y ) ;
	void set_point ( unsigned x, unsigned y, unsigned char colour ) ;
	void draw_line ( unsigned x1, unsigned y1,
                   unsigned x2, unsigned y2,
                   unsigned char colour,
                   unsigned char width,
                   unsigned char style ) ;
	void draw_circle ( unsigned x, unsigned y,
                     unsigned radius, unsigned char colour,
                     unsigned char width,
                     unsigned char style ) ;
	unsigned char read_pixel ( unsigned x, unsigned y ) ;
	void colour_change ( unsigned char colour ) ;
	void clear_window ( unsigned char colour ) ;
	void txfr_to_display_window ( HDC hDC, unsigned x_pixels, unsigned y_pixels ) ;
	// new in v4.0 - define palette entry
	void define_palette_entry ( int pal_entry, unsigned char red,
					unsigned char green, unsigned char blue ) ;
} ;

extern const COLORREF fpalette[] ;
