/*
HNC INDIVIDUAL PROJECT PC REMOTE SHARER SYSTEM
PACKAGE MISC_UTILS
CREATED ON February 1, 1995, 07:14 PM BY J.BIRD
MOD ON October 8, 1995, FOR V2.03 BY J.BIRD
MOD ON October 12 1996, FOR V2.2 BY J.Bird
MOD ON November 25 1996, FOR V3.0 BY J.Bird
MOD ON July 31 1999, FOR V4.0 BY J.Bird

Package Message_Processor.Misc_Utils is

DESCRIPTION

This package provides the ability to execute any messages that do not fall
into any specific category (file transfer, graphics). Currently two
miscellaneous operations are defined:

-- Execute a DOS command string.

REQUIRED INTERFACE
 None
*/
#include <stdlib.h>
#include <dos.h>
/*
Types/Data
 NONE

PROVIDES OPERATIONS
 EXECUTE_DOS_COMMAND

INTERNAL OPERATIONS
 None

END.
*/

// V3.0 - DOS command forking not supported

// new in V2.2 - read and package up system clock information
void read_system_clock ( unsigned char *data_packet )
{
	struct time timep ;
	struct date datep ;

  // v4.0 - structure change for 4 digit date code
	struct time_packet_type
	{ unsigned char MSyear ;
    unsigned char LSyear ;
	  unsigned char month ;
	  unsigned char day ;
	  unsigned char hours ;
	  unsigned char minutes ;
	  unsigned char seconds ; } ;

	struct time_packet_type *time_packet = (struct time_packet_type*)data_packet ;

	getdate ( &datep ) ;
	gettime ( &timep ) ;

  // v4.0 - provide 4 digit date code
  time_packet->MSyear = datep.da_year / 100 ;
	time_packet->LSyear = datep.da_year % 100 ;
	time_packet->month = datep.da_mon ;
	time_packet->day = datep.da_day ;
	time_packet->hours = timep.ti_hour ;
	time_packet->minutes = timep.ti_min ;
	time_packet->seconds = timep.ti_sec ;
}

