/*
HNC INDIVIDUAL PROJECT PC REMOTE SHARER SYSTEM
PACKAGE MONITOR
CREATED ON February 1, 1995, 07:13 PM BY J.BIRD
MOD ON September 22 1995, FOR V2.01 BY J.Bird
MOD ON February 18 1996, FOR V2.1 BY J.Bird
MOD ON May 30, 1996, FOR V3.0 BY J.Bird
MOD ON October 29 1997, FOR V3.02 BY J.Bird
MOD ON March 13 1998, FOR V4.0 BY J.Bird
MOD ON May 01 2000, FOR V4.1 BY J.Bird
MOD ON December 27 2000, FOR V4.11 BY J.Bird

Package Monitor is

DESCRIPTION

The MONITOR package is responsible for the overall control of the PC Remote
Sharer system. It performs system wide initialisation, and monitors the state
of the system for any activity.

REQUIRED INTERFACE

 KEYBOARD
 MESSAGE_PROCESSOR
 UTILITIES_MONITOR
 SYSTEM_CONFIG
*/
#include <windows.h>
#include <windowsx.h>
#include <stdio.h>
#include <alloc.h>
#include <process.h>
#include "pcshare.h"
#include "utilitie.h"
#include "message.h"
#include "config.h"
#include "video_ct.h"
#include <bwcc.h>

//Types/Data

#define szAppName "PCShareWin"
#define EXE_NAME_MAX_SIZE 200

// instance of application
HINSTANCE hInst ;
HWND Main_hWnd ;
HMENU Window_hMenu ;
static int i ;
static HANDLE MsgEvent, MsgDone ;
static volatile BOOL MessgEvent = FALSE ;

char helpfilename[EXE_NAME_MAX_SIZE+1] ;

/*
Provides Operations
 MAIN

Internal Operations
 INITIALISE_MAIN
*/
LRESULT CALLBACK WndProc (HWND, UINT, WPARAM, LPARAM);
int initialise_main(HINSTANCE hInstance, HINSTANCE hPrevInstance,
						 LPSTR lpszCmdLine, int nCmdShow) ;
int  DoWMCommand(WORD wParam, HWND hWnd);
BOOL CALLBACK _export AboutPCShare (HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK _export OpeningTitle (HWND, UINT, WPARAM, LPARAM);
void GetBitmapResource ( HDC hdc, int resource,
									HBITMAP *hbitmap, HPALETTE *hpalette ) ;
void ExtEventThread ( void *p ) ;

/*
END.
*/

/*
HNC INDIVIDUAL PROJECT PC REMOTE SHARER SYSTEM
INTERNAL OPERATION INITIALISE_MAIN
CREATED ON February 1, 1995, 07:13 PM BY J.BIRD
MOD ON September 22 1995, FOR V2.01 BY J.Bird
MOD ON February 18 1996, FOR V2.1 BY J.Bird
MOD ON May 30, 1996, FOR V3.0 BY J.Bird
MOD ON March 13 1998, FOR V4.0 BY J.Bird

Procedure Initialise_Main is
*/
int initialise_main(HINSTANCE hInstance, HINSTANCE hPrevInstance,
						 LPSTR lpszCmdLine, int nCmdShow)
/*
DESCRIPTION

This operation is reponsible for perfoming any initialisation that is required
by the software upon start up.

USES OPERATIONS
 SYSTEM_CONFIG.DISPLAY_CONFIG_DATA
 MESSAGE_PROCESSOR.INIT_MESSAGE_PROCESSOR

Types/Data
*/
{
	 WNDCLASS    wndClass;
	 HWND        hWnd, hDlg;
	 HMENU main_menu ;
	char *  pcFileName;
	int     nFileNameLen;

/*
PSUEDO CODE

	Config.Display_Config_Data ;
	Message_Processor.Initialise_Message_Processor ;

CODE
*/
	 if (!hPrevInstance)
	 {
		  wndClass.style          = CS_HREDRAW | CS_VREDRAW | CS_BYTEALIGNWINDOW ;
		  wndClass.lpfnWndProc    = WndProc;
		  wndClass.cbClsExtra     = 0;
		  wndClass.cbWndExtra     = 0;
		  wndClass.hInstance      = hInstance;
		  wndClass.hIcon          = LoadIcon ( hInstance, MAKEINTRESOURCE ( PCSHARE_ICON ) ) ;
		  wndClass.hCursor        = LoadCursor(NULL, IDC_ARROW);
		  wndClass.hbrBackground  = (HBRUSH)GetStockObject ( WHITE_BRUSH ) ;
		  wndClass.lpszMenuName   = NULL ; // MAKEINTRESOURCE ( MAIN_MENU ) ;
		  wndClass.lpszClassName  = szAppName;

		  if (!RegisterClass(&wndClass))
				return FALSE;
	 }
	 else
	 {
		MessageBox ( NULL, "PCShare already active",
						"Startup Error", MB_OK | MB_ICONSTOP ) ;
		return FALSE ;
	 }

	 // need this for other stuff
	 hInst = hInstance ;

	 BWCCRegister ( hInst ) ;

	 // fetch full name of executable for helpfile
	 nFileNameLen = GetModuleFileName(hInst,helpfilename,EXE_NAME_MAX_SIZE) ;

	// set pointer to end of modulename
	pcFileName = helpfilename + nFileNameLen;

	// look for start of executable (.EXE) bit and terminate string
	// when found
	while (pcFileName > helpfilename) {
		 if (*pcFileName == '\\' || *pcFileName == ':') {
			  *(++pcFileName) = '\0';
			  break;
		 }
	nFileNameLen--;
	pcFileName--;
	}

	// replace with help filename
	if ((nFileNameLen+13) < EXE_NAME_MAX_SIZE) {
		 lstrcat(helpfilename, "pcshare4.hlp");
	}

	else {
		 lstrcat(helpfilename, "?");
	}

	 // title dialog box
	 CreateDialog ( hInst, MAKEINTRESOURCE ( PCS_TITLE ), Main_hWnd, (DLGPROC)OpeningTitle ) ;
	 DialogBox ( hInst, MAKEINTRESOURCE ( ABOUT_PCSHARE ), Main_hWnd, (DLGPROC)AboutPCShare ) ;

	 hWnd = CreateWindow(szAppName, "PCShare 4.1",
					WS_OVERLAPPED | WS_SYSMENU | WS_MINIMIZEBOX, 0,0,
					300,300, NULL, NULL, hInstance, NULL);

	 ShowWindow(hWnd, SW_MINIMIZE	);
	 Main_hWnd = hWnd ;
	 UpdateWindow(hWnd);

	 // get the handle of the 'windows' popup so the window
	 // names can be added to it by the video_ctrl module
	 main_menu = GetMenu ( hWnd ) ;

	get_config_data() ;
	open_message_processor () ;
	update_utils( TRUE ) ;
  // event flags - MsgEvent flagged by event thread to main
  // indicating new message, MsgDone flagged back indicated processing done
  MsgEvent = CreateEvent ( NULL, FALSE, FALSE, NULL ) ;
  MsgDone = CreateEvent ( NULL, FALSE, FALSE, NULL ) ;
  _beginthread ( ExtEventThread, 4096, NULL ) ;
	return TRUE ;
}
/*
END.
*/

/*
HNC INDIVIDUAL PROJECT PC REMOTE SHARER SYSTEM
PROVIDED OPERATION MAIN
CREATED ON February 1, 1995, 07:13 PM BY J.BIRD
MOD ON September 22 1995, FOR V2.01 BY J.Bird
MOD ON February 18 1996, FOR V2.1 BY J.Bird
MOD ON May 30, 1996, FOR V3.0 BY J.Bird

Procedure MAIN is
*/
int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
						 LPSTR lpszCmdLine, int nCmdShow)
/*
DESCRIPTION

This operation is called when the DOS executable is run. It will initialise
any system variables required, and then loop to service events within the
system. When an event is detected, the utilities monitor is first informed that
a system event is about to occur then the event is serviced. When no events are
due, the utilities monitor is called to perform any background tasks.

USES OPERATIONS
 INITIALISE_MAIN
 UTILITIES_MONITOR.UPDATE_UTILS
 MESSAGE_PROCESSOR.MESSAGE_EVENT
 MESSAGE_PROCESSOR.PROCESS_MESSAGE
 MESSAGE_PROCESSOR.CLOSE_MESSAGE_PROCESSOR
 KEYBOARD.KEYPRESS_DETECTED
 KEYBOARD.PROCESS_KEYPRESS
 CONFIG.SAVE_CONFIG_DATA

Types/Data
 None
*/
{
	 MSG         msg;
	 int quit = FALSE ;
   DWORD EvReturn ;

/*
PSUEDO CODE

 Initialise_Main ;

 while quit_key_not_pressed
 loop

	if Message_Processor.Message_Event
	then

		Utilities_Monitor.Update_Utils ( Event_Pending => TRUE ) ;
		Message_Processor.Process_Message ;

	end if ;

	if Keyboard.Keypress_Detected
	then

		Utilities_Monitor.Update_Utils ( Event_Pending => TRUE ) ;
		Keyboard.Process_Keypress ;
	end if ;

	Utilities_Monitor.Update_Utils ( Event_Pending => FALSE ) ;

 end loop ;

 Message_Processor.Close_Processor ;
 Config.Save_Config ;

CODE
*/

	if ( !initialise_main (hInstance,hPrevInstance,lpszCmdLine,nCmdShow) )
		return FALSE ;

	// main processing loop
  while ( !quit )
  {
    // wait on win-msg or remote messg event
    EvReturn = MsgWaitForMultipleObjects ( 1,
                                           &MsgEvent,
                                           FALSE,
                                           INFINITE,
                                           QS_ALLINPUT ) ;

    // check return
    if ( !(EvReturn - WAIT_OBJECT_0) )
    {
      // process message, flag messg done to unlock thread
			process_message() ;
      SetEvent ( MsgDone ) ;
    }
    else
    {
      // process all messages in queue
		  while( PeekMessage ( &msg, NULL, 0, 0, PM_REMOVE ) )
		  {
			  if ( msg.message == WM_QUIT )
				  quit = TRUE ;

  			TranslateMessage(&msg);
	  		DispatchMessage(&msg);
  		}
    }
  }

/*
  while (GetMessage(&msg, NULL, 0, 0))
	{
	  TranslateMessage(&msg);
	  DispatchMessage(&msg);

		// handle PCShare messages
		if ( MessgEvent )
    {
			process_message() ;
      MessgEvent = FALSE ;
      SetEvent ( EvHandle ) ;
		}
	}
*/

	close_message_processor() ;
  CloseHandle ( MsgDone ) ;
  CloseHandle ( MsgEvent ) ;
	return 0 ;
}
/*
END.
*/

/* thread to handle events from pc-share host processor */
void ExtEventThread ( void *p )
{
  while ( 1 )
  {
    // look for event on port
    if ( message_event() )
    {
      /* wakeup main loop on message event */
//      MessgEvent = TRUE ;
//      PostMessage ( Main_hWnd, WM_NULL, 0, 0 ) ;

      // flag up to main thread
      SetEvent ( MsgEvent ) ;

      /* wait for main loop to process message */
      WaitForSingleObject ( MsgDone, INFINITE ) ;
    }
  }
}

LRESULT CALLBACK WndProc (HWND hWnd, UINT Message,
								  WPARAM wParam, LPARAM lParam)
{
HDC hdc, hdcMem ;
HBITMAP hbitmap ;
HBITMAP old_bitmap ;
BITMAP bitmap ;
PAINTSTRUCT ps ;
HMENU sys_menu, pop_menu, pop_menu2 ;

	 switch(Message)
	 {
		  case WM_COMMAND:
				return DoWMCommand(wParam, hWnd);

      case WM_QUERYOPEN :
        return 0 ;

		  case WM_CREATE :

//				return DefWindowProc(hWnd, Message, wParam, lParam);

				// proceed to modify the system menu to include the PCShare main menu
				sys_menu = GetSystemMenu ( hWnd, FALSE ) ;
				// get rid of the stuff we don't want
        EnableMenuItem ( sys_menu, SC_MOVE, MF_GRAYED ) ;
//				ModifyMenu ( sys_menu, SC_MOVE, MF_BYCOMMAND | MF_GRAYED,
//					3000, "Move" ) ;

				DeleteMenu ( sys_menu, SC_SIZE, MF_BYCOMMAND ) ;
				DeleteMenu ( sys_menu, SC_MINIMIZE, MF_BYCOMMAND ) ;
				DeleteMenu ( sys_menu, SC_MAXIMIZE, MF_BYCOMMAND ) ;
				DeleteMenu ( sys_menu, SC_RESTORE, MF_BYCOMMAND ) ;

				// pop2 is the colours menu
				pop_menu2 = CreatePopupMenu () ;
				AppendMenu ( pop_menu2, MF_ENABLED, MAIN_FORECOLOUR, "Foreground Colour" ) ;
				AppendMenu ( pop_menu2, MF_ENABLED, MAIN_BACKCOLOUR, "Background Colour" ) ;

				// pop is the config menu - which pop2 hangs off
				pop_menu = CreatePopupMenu () ;
				AppendMenu ( pop_menu, MF_ENABLED, MAIN_CONFIG, "Settings" ) ;
				AppendMenu ( pop_menu, MF_ENABLED, MAIN_KEYMAP, "Keyboard Map" ) ;
				AppendMenu ( pop_menu, MF_POPUP, (UINT)pop_menu2, "Colours" ) ;
				AppendMenu ( pop_menu, MF_ENABLED, MAIN_FONT, "Font" ) ;

				// attach the config popup to the system menu
				AppendMenu ( sys_menu, MF_POPUP, (UINT)pop_menu, "Config" ) ;

				// pop is the windows menu
				pop_menu = CreatePopupMenu() ;
				AppendMenu ( pop_menu, MF_ENABLED, MAIN_HORIZONTAL, "Tile Horizontal" ) ;
				AppendMenu ( pop_menu, MF_ENABLED, MAIN_VERTICAL, "Tile Vertical" ) ;
				AppendMenu ( pop_menu, MF_ENABLED, MAIN_CASCADE, "Cascade" ) ;
				AppendMenu ( pop_menu, MF_SEPARATOR, 0, NULL ) ;
				AppendMenu ( pop_menu, MF_ENABLED, MAIN_CLOSEALL, "Close All" ) ;
				AppendMenu ( pop_menu, MF_ENABLED, MAIN_MINIMIZEALL, "Minimize All" ) ;
				AppendMenu ( pop_menu, MF_ENABLED, MAIN_RESTOREALL, "Restore All" ) ;
				Window_hMenu = pop_menu ;

				// attach windows popup to system menu
				AppendMenu ( sys_menu, MF_POPUP, (UINT)pop_menu, "Windows" ) ;

				// pop menu is the help menu
				pop_menu = CreatePopupMenu() ;
				AppendMenu ( pop_menu, MF_ENABLED, CM_HELPABOUT, "About..." ) ;
				AppendMenu ( pop_menu, MF_SEPARATOR, 0, NULL ) ;
				AppendMenu ( pop_menu, MF_ENABLED, CM_HELPINDEX, "Index" ) ;
				AppendMenu ( pop_menu, MF_ENABLED, CM_HELPCOMMANDS, "Commands" ) ;
				AppendMenu ( pop_menu, MF_ENABLED, CM_HELPPROCEDURES, "Procedures" ) ;
				AppendMenu ( pop_menu, MF_ENABLED, CM_HELPUSING_HELP, "Using Help" ) ;

				// attach help menu to system menu
				AppendMenu ( sys_menu, MF_POPUP, (UINT)pop_menu, "Help" ) ;
				break ;

		  case WM_DESTROY:
				// closedown help
				WinHelp(hWnd,helpfilename,HELP_QUIT,0L);
				PostQuitMessage(0);
				break;

		  case WM_KEYDOWN:
				if (wParam == VK_F1)
					WinHelp(hWnd,helpfilename,HELP_INDEX,0L);
				break ;

		  case WM_SYSCOMMAND :

				if ( DoWMCommand(wParam, hWnd) )
				  return DefWindowProc(hWnd, Message, wParam, lParam);
				else
					return 0 ;

		  default:
				return DefWindowProc(hWnd, Message, wParam, lParam);
	 }
	 return 0;
}

/*********************************************************************
 * function DoWMCommand
 *    When a menu item is selected, this function changes the current
 *    state of shape selections to match the user's menu selection.
 *******************************************************************/
int DoWMCommand(WORD wParam, HWND hWnd)
{
	int i, win_count, win_size, win_pos, win_size2 ;
	HWND desk_hwnd ;
	RECT rc ;

	 // make the selected window active
	 if ( wParam >= WINDOW_BASE_ID && wParam < WINDOW_BASE_ID+MAX_WINDOWS )
	 {
		SetActiveWindow ( active_windows[wParam-WINDOW_BASE_ID]->MainWnd ) ;
		ShowWindow ( active_windows[wParam-WINDOW_BASE_ID]->MainWnd, SW_RESTORE ) ;
		return 0 ;
	 }

	 switch(wParam)
	 {

		  case SC_CLOSE :

			 // count active windows
			 win_count = 0 ;
			 for ( i=0 ; i< MAX_WINDOWS ; i++ )
			 {
				if ( active_windows[i] != NULL )
					win_count++ ;
			 }
			 // if any are active
			 if ( win_count != 0 )
			 {
				// close down all windows if user confirms the action
				if ( MessageBox ( hWnd, "Windows are still active, Confirm Quit?",
					"Close PCShare", MB_OKCANCEL | MB_ICONQUESTION ) == IDOK )
				{
					DestroyWindow ( hWnd ) ;
				}
			 }
			 else
				DestroyWindow ( hWnd ) ;
			return 0 ;

		  case MAIN_CONFIG :
				display_config_data() ;
				return 0 ;

		  case MAIN_FONT :
				if ( get_new_font ( hWnd, &system_config.font, &system_config.fore_colour ) )
					save_config_data() ;
				return 0 ;

		  case MAIN_FORECOLOUR :
				 if ( get_new_colour ( hWnd, &system_config.fore_colour ) )
				 	save_config_data() ;
				 return 0 ;

		  case MAIN_BACKCOLOUR :
				 if ( get_new_colour ( hWnd, &system_config.back_colour ) )
				 	save_config_data() ;
				 return 0 ;

		  case MAIN_KEYMAP :
				 if ( DialogBoxParam ( hInst, MAKEINTRESOURCE ( KEYMAPS ), Main_hWnd,
					(DLGPROC)DefineKeyMap, (LPARAM)&system_config.keymap ) )
				 	save_config_data() ;
				 return 0 ;

		  case MAIN_HORIZONTAL :

				 // get dimensions of the screen
				 desk_hwnd = GetDesktopWindow () ;
				 GetWindowRect ( desk_hwnd, &rc ) ;
				 // count active windows
				 win_count = 0 ;
				 for ( i=0 ; i< MAX_WINDOWS ; i++ )
				 {
					if ( active_windows[i] != NULL )
						win_count++ ;
				 }
				 // if any are active
				 if ( win_count != 0 )
				 {
					// determine new height of each window
					win_size = (rc.bottom-rc.top) / win_count ;
					win_pos = 0 ;
					for ( i=0 ; i < MAX_WINDOWS ; i++ )
					{
						// for each active window, adjust for the new size
						if ( active_windows[i] != NULL )
						{
							ShowWindow ( active_windows[i]->MainWnd, SW_RESTORE ) ;
							MoveWindow ( active_windows[i]->MainWnd, 0, win_pos,
								(rc.right-rc.left), win_size, TRUE ) ;
							win_pos+=win_size ;
						}
					}
				 }
				 return 0 ;

		  case MAIN_CASCADE :

				 // get dimensions of the screen
				 desk_hwnd = GetDesktopWindow () ;
				 GetWindowRect ( desk_hwnd, &rc ) ;
				 win_size=(rc.right-rc.left)/2 ;
				 win_size2=(rc.bottom-rc.top)/2 ;
				 win_pos=50 ;
				 for ( i=0 ; i < MAX_WINDOWS ; i++ )
				 {
					if ( active_windows[i] != NULL )
					{
						ShowWindow ( active_windows[i]->MainWnd, SW_RESTORE ) ;
						MoveWindow ( active_windows[i]->MainWnd, win_pos, win_pos,
							win_pos+win_size, win_pos+win_size2, TRUE ) ;
						win_pos+=30 ;
						SetActiveWindow ( active_windows[i]->MainWnd ) ;
					}
				 }
				 return 0 ;

		  case MAIN_VERTICAL :

				 // get screen dimensions
				 desk_hwnd = GetDesktopWindow () ;
				 GetWindowRect ( desk_hwnd, &rc ) ;
				 // count active windows
				 win_count = 0 ;
				 for ( i=0 ; i< MAX_WINDOWS ; i++ )
				 {
					if ( active_windows[i] != NULL )
						win_count++ ;
				 }
				 if ( win_count != 0 )
				 {
					// new window size
					win_size = (rc.right-rc.left) / win_count ;
					win_pos = 0 ;
					// re-size all active windows
					for ( i=0 ; i < MAX_WINDOWS ; i++ )
					{
						if ( active_windows[i] != NULL )
						{
							ShowWindow ( active_windows[i]->MainWnd, SW_RESTORE ) ;
							MoveWindow ( active_windows[i]->MainWnd, win_pos, 0,
								win_size, (rc.bottom-rc.top), TRUE ) ;
							win_pos+=win_size ;
						}
					}
				 }
				 return 0 ;

		  case MAIN_CLOSEALL :

				 // count active windows
				 win_count = 0 ;
				 for ( i=0 ; i< MAX_WINDOWS ; i++ )
				 {
					if ( active_windows[i] != NULL )
						win_count++ ;
				 }
				 // if any are active
				 if ( win_count != 0 )
				 {
					// close down all windows if user confirms the action
					if ( MessageBox ( hWnd, "Close All Host's active windows?",
						"Close Active Windows", MB_OKCANCEL | MB_ICONQUESTION ) == IDOK )
					{
						for (i=0 ; i<MAX_WINDOWS ; i++ )
						{
							if ( active_windows[i] != NULL )
							{
								delete active_windows[i] ;
								active_windows[i] = NULL ;
							}
						}
					}
				 }
				 return 0 ;

		  case MAIN_MINIMIZEALL :

				// minimize all active windows
				for (i=0 ; i<MAX_WINDOWS ; i++ )
				{
					if ( active_windows[i] != NULL )
						ShowWindow ( active_windows[i]->MainWnd, SW_MINIMIZE ) ;
				}
				return 0 ;

		  case MAIN_RESTOREALL :

				// restore all active windows
				for (i=0 ; i<MAX_WINDOWS ; i++ )
				{
					if ( active_windows[i] != NULL )
						ShowWindow ( active_windows[i]->MainWnd, SW_RESTORE ) ;
				}
				return 0 ;

		  case CM_HELPINDEX :

			 WinHelp(hWnd,helpfilename,HELP_INDEX,0L);
			return 0 ;

		  case CM_HELPCOMMANDS :

			 WinHelp(hWnd,helpfilename,HELP_KEY,(DWORD)(LPSTR)"commands");
			return 0 ;

		  case CM_HELPPROCEDURES :

			 WinHelp(hWnd,helpfilename,HELP_KEY,(DWORD)(LPSTR)"procedures");
			return 0 ;

		  case CM_HELPUSING_HELP :

			 WinHelp(hWnd,"WINHELP.HLP",HELP_INDEX,0L);
			return 0 ;

		  case CM_HELPABOUT :

			 DialogBox ( hInst, MAKEINTRESOURCE ( ABOUT_PCSHARE ), Main_hWnd, (DLGPROC)AboutPCShare ) ;
			return 0 ;

	 }
	 return 1 ;
}

#pragma argsused
BOOL CALLBACK _export AboutPCShare (HWND hDlg, UINT Message,
								  WPARAM wParam, LPARAM lParam)
{
HDC hdc, hdcMem ;
PAINTSTRUCT ps ;
HBITMAP hbitmap, old_bitmap ;
HPALETTE hpalette, old_palette, old_mempalette ;
SIZE bitmap_size ;

	switch ( Message )
	{
		case WM_INITDIALOG :
#ifdef __WIN32__
			SetDlgItemText ( hDlg, PCSHARE_VERSION, "PCShare for Windows(32)" ) ;
#endif
			return 1 ;

		case WM_PAINT :

			// responsible for bitblting the title bitmap onto the dialog box
			BeginPaint ( hDlg, &ps ) ;

			hdc = ps.hdc ;

			// get bitmap handle and palette
			GetBitmapResource ( hdc, ABOUT_LOGO, &hbitmap, &hpalette ) ;
			GetBitmapDimensionEx ( hbitmap, &bitmap_size ) ;

         // create device context & select in bitmap
			hdcMem = CreateCompatibleDC ( hdc ) ;
			old_bitmap = SelectObject ( hdcMem,hbitmap ) ;
         // load in palettes
			old_mempalette = SelectPalette ( hdcMem, hpalette, FALSE ) ;
			old_palette = SelectPalette ( hdc, hpalette, FALSE ) ;
			i=RealizePalette ( hdc ) ;

         // display bitmap
			BitBlt ( hdc, 0, 0, bitmap_size.cx,
         	bitmap_size.cy, hdcMem, 0, 0, SRCCOPY ) ;

         // clean up
			SelectPalette ( hdcMem, old_mempalette, 0 ) ;
			SelectPalette ( hdc, old_palette, 0 ) ;
			SelectObject ( hdcMem, old_bitmap ) ;
			DeleteDC ( hdcMem ) ;
			DeleteObject ( hbitmap ) ;
			DeleteObject ( hpalette ) ;
			EndPaint ( hDlg, &ps ) ;
         return 0 ;

		case WM_COMMAND :

			switch ( GET_WM_COMMAND_ID ( wParam, lParam ) )
			{
				case IDOK :

					EndDialog ( hDlg, 0 ) ;
					return 1 ;
			}
			break ;
	}
	return 0 ;
}

// displays the nice snazzy title for a bit
BOOL CALLBACK _export OpeningTitle (HWND hDlg, UINT Message,
								  WPARAM wParam, LPARAM lParam)
{
HWND ScreenWnd ;
RECT ScreenRC, TitleRC ;
int width, height, top, left ;
HDC hdc, hdcMem ;
PAINTSTRUCT ps ;
HBITMAP hbitmap, old_bitmap ;
HPALETTE hpalette, old_mempalette, old_palette ;
SIZE bitmap_size ;

	switch ( Message )
	{
		case WM_INITDIALOG :

			// work out size of screen and size of title in order
			// to position it centrally on the user's current screen
			ScreenWnd = GetDesktopWindow() ;
			GetClientRect ( ScreenWnd, &ScreenRC ) ;
			GetClientRect ( hDlg, &TitleRC ) ;
			width = TitleRC.right-TitleRC.left ;
			height = TitleRC.bottom-TitleRC.top ;
			left = (ScreenRC.right-ScreenRC.left)/2 - width/2 ;
			top = (ScreenRC.bottom-ScreenRC.top)/2 - height/2 ;
			MoveWindow ( hDlg, left, top, width, height, TRUE ) ;
			// setup a 5s timer
			SetTimer ( hDlg, 1, 5000, NULL ) ;
			return 1 ;

		case WM_TIMER :

			// when timer expires, kill off the title dialog
			KillTimer ( hDlg, 1 ) ;
			DestroyWindow( hDlg ) ;
			return 0 ;

		case WM_PAINT :

			// responsible for bitblting the title bitmap onto the dialog box
			BeginPaint ( hDlg, &ps ) ;

			// create compatible device context
			hdc = ps.hdc ;
			hdcMem = CreateCompatibleDC ( hdc ) ;

			// get bitmap handle and palette
			GetBitmapResource ( hdc, PCS_LOGO, &hbitmap, &hpalette ) ;

			GetBitmapDimensionEx ( hbitmap, &bitmap_size ) ;

         // load in palettes
			old_mempalette = SelectPalette ( hdcMem, hpalette, FALSE ) ;
			old_palette = SelectPalette ( hdc, hpalette, FALSE ) ;
			RealizePalette ( hdc ) ;

         // load in bitmap
			old_bitmap = SelectObject ( hdcMem,hbitmap ) ;

			// display the title
			BitBlt ( hdc, 0, 0, bitmap_size.cx,
         	bitmap_size.cy, hdcMem, 0, 0, SRCCOPY ) ;

			// restore old bitmaps and palettes
			SelectObject ( hdcMem, old_bitmap ) ;
			SelectPalette ( hdcMem, old_mempalette, 0 ) ;
			SelectPalette ( hdc, old_palette, 0 ) ;

			// clean up
			DeleteDC ( hdcMem ) ;
			DeleteObject ( hpalette ) ;
			DeleteObject ( hbitmap ) ;

			EndPaint ( hDlg, &ps ) ;
			return 0 ;
	}
	return 0 ;
}

// get a bitmap handle and associated palette from a
// bitmap resource id
void GetBitmapResource ( HDC hdc, int resource,
									HBITMAP *hbitmap, HPALETTE *hpalette )
{
	HRSRC bmap_hsrc ;
	HGLOBAL bmap_handle ;
	unsigned char *bmap_data ;
	RGBQUAD *bmap_pal ;
	unsigned char *bmap_bits ;
	BITMAPINFO *bmap_hdr ;
	LOGPALETTE *lpal ;
	int i ;
	HPALETTE old_palette ;
   SIZE bitmap_size ;

   // get pointer to bitmap resource
	bmap_hsrc = FindResource ( hInst, MAKEINTRESOURCE ( resource ), RT_BITMAP ) ;
	bmap_handle = LoadResource ( hInst, bmap_hsrc ) ;
	bmap_data = (unsigned char*)LockResource ( bmap_handle ) ;
	// set pointers to bitmap header, palette and data
	bmap_hdr = (BITMAPINFO*)bmap_data ;
	bmap_pal = (RGBQUAD*)((unsigned char*)bmap_data+sizeof ( BITMAPINFOHEADER )) ;
	bmap_bits = (unsigned char*)((unsigned char*)bmap_data+sizeof ( BITMAPINFOHEADER ) +
						sizeof ( RGBQUAD ) * 256 ) ;

	// allocate structure for new palette
	lpal = (LOGPALETTE*)malloc ( sizeof ( LOGPALETTE ) +
				  sizeof ( PALETTEENTRY ) * 256 ) ;

	// map bitmap palette to colour palette structure
	lpal->palNumEntries = 256 ;
	lpal->palVersion = 0x300 ;
	for ( i=0 ; i<256 ; i++ )
	{
		lpal->palPalEntry[i].peRed = bmap_pal[i].rgbRed ;
		lpal->palPalEntry[i].peGreen = bmap_pal[i].rgbGreen ;
		lpal->palPalEntry[i].peBlue = bmap_pal[i].rgbBlue ;
		lpal->palPalEntry[i].peFlags = NULL ;
	}

	// create new palette
	*hpalette = CreatePalette ( lpal ) ;

   // delete palette array
	free ( lpal ) ;

   // create bitmap compatible with the supplied device context
	*hbitmap = CreateCompatibleBitmap ( hdc,
         		bmap_hdr->bmiHeader.biWidth, bmap_hdr->bmiHeader.biHeight ) ;

   SetBitmapDimensionEx ( *hbitmap, bmap_hdr->bmiHeader.biWidth,
   										bmap_hdr->bmiHeader.biHeight, NULL ) ;

   // switch palette into device context and copy the bitmap bits
   // into the bitmap
	old_palette = SelectPalette ( hdc, *hpalette, FALSE ) ;
	RealizePalette ( hdc ) ;
	SetDIBits ( hdc, *hbitmap, 0, bmap_hdr->bmiHeader.biHeight,
	         			bmap_bits, bmap_hdr, DIB_RGB_COLORS ) ;

   // restore the old palette
	SelectPalette ( hdc, old_palette, 0 ) ;

   // release the resource
	UnlockResource ( bmap_handle ) ;
	FreeResource ( bmap_handle ) ;
}

