// RS232 comms package required to interface to the DMS monitor
typedef struct
	 {
	 int comport;   /* comm 1,2,3,4 */
	 int irq;       /* irq, set to 0 for default */
	 int baud;      /* see below */
	 int bits;      /* data bits */
	 int parity;    /* see below */
	 int stops;     /* stop bits */
	 }
serial_232_t;

/*
	 baud:

		  0 -   110
		  1 -   150
		  2 -   300
		  3 -  1200
		  4 -  2400
		  5 -  4800
		  6 -  9600
		  7 - 19200

	 parity:
		  0 - none
		  1 - odd
		  2 - even
		  3 - mark
		  4 - space

*/
#ifndef __WIN32__
enum
	 {
	 BAUD_110,
	 BAUD_150,
	 BAUD_300,
	 BAUD_1200,
	 BAUD_2400,
	 BAUD_4800,
	 BAUD_9600,
	 BAUD_19200,
	 BAUD_38400,
	 BAUD_57600,
	 BAUD_115200
	 };

enum
	 {
	 PARITY_NONE,
	 PARITY_ODD,
	 PARITY_EVEN,
	 PARITY_MARK,
	 PARITY_SPACE
	 };
#endif

unsigned char read_rs232 ( void ) ;
void write_rs232 ( unsigned char out_byte ) ;
int init_rs232 ( serial_232_t *port_init ) ;
void de_init_rs232 ( void ) ;
int rs232_ready ( void ) ;


