// response codes passed back to window access specific to VT100
#define SAVE_ATTRS 0x30
#define REST_ATTRS 0x31
#define SET_TAB 0x32
#define RESET_TERM 0x33
#define NO_ATTRS 0x34
#define BOLD_ON 0x35
#define BOLD_OFF 0x36
#define BLINK_ON 0x37
#define INVISIBLE_ON 0x38
#define WIDTH_132 0x39
#define WIDTH_80 0x3A
#define AUTO_WRAP 0x3B
#define RESET_WRAP 0x3C
#define CLEAR_TAB 0x3D
#define CLEAR_LEFT 0x3E
#define CLEAR_TOS 0x3F
#define CLEAR_AOS 0x40
#define CLEAR_LINE 0x41

class vt100_emulator : public common_emulator {
private:
	// data and variables
	int VT100_level ;
	int numeric_param[5] ;
	int param_count, current_param ;
	int multiplier ;
	int open_bracket_flag ;
	int tab_array[80] ;
	char pending, pending_char ;
	// operations
	void init_numeric_param ( void ) ;
	void process_numeric_param ( char textcr ) ;
	int process_sqr_bracket_sequence ( char textcr ) ;
	int process_question_mark_sequence ( char textcr ) ;
	int process_round_bracket_seq ( char textcr ) ;
	int process_hash_sequence ( char textcr ) ;
	int process_misc_sequence ( char textcr ) ;
public:
	// data and variables
	// operations
	vt100_emulator() ;
	int process_emulation_sequence ( char textcr ) ;
	int emulation_detect ( char textcr ) ;
	int emulation_in_progress ( void ) ;
	int emulation_sequence_pending ( void ) ;
	int find_next_tab ( int current_x ) ;
	void modify_tab ( int column, char set_flag ) ;
} ;
